# is-valid-app [![NPM version](https://img.shields.io/npm/v/is-valid-app.svg?style=flat)](https://www.npmjs.com/package/is-valid-app) [![NPM monthly downloads](https://img.shields.io/npm/dm/is-valid-app.svg?style=flat)](https://npmjs.org/package/is-valid-app)  [![NPM total downloads](https://img.shields.io/npm/dt/is-valid-app.svg?style=flat)](https://npmjs.org/package/is-valid-app) [![Linux Build Status](https://img.shields.io/travis/node-base/is-valid-app.svg?style=flat&label=Travis)](https://travis-ci.org/node-base/is-valid-app)

> Wrapper around is-valid-instance and is-registered for validating `base` plugins. Returns true if `app` is a valid instance of base and a plugin is not registered yet.

## Install

Install with [npm](https://www.npmjs.com/):

```sh
$ npm install --save is-valid-app
```

## Usage

```js
var isValid = require('is-valid-app');

// in your Base plugin
function plugin(app) {
  // plugin name is required as the second argument
  if (!isValid(app, 'my-plugin')) return;
  // do plugin stuff
}
```

Optionally pass an array of instance types as the third argument:

```js
function plugin(app) {
  if (!isValid(app, 'my-plugin', ['view', 'collection'])) return;
  // do plugin stuff
}
```

Visit [base](https://github.com/node-base/base) for more details.

## History

**v0.3.0**

* upgrades [is-valid-instance](https://github.com/jonschlinkert/is-valid-instance) to v0.3.0, which adds support for checking `app.type` for the instance type. We don't expect any regressions, but if you experience one, please [create an issue](../../issues/new).

## About

### Related projects

* [base](https://www.npmjs.com/package/base): base is the foundation for creating modular, unit testable and highly pluggable node.js applications, starting… [more](https://github.com/node-base/base) | [homepage](https://github.com/node-base/base "base is the foundation for creating modular, unit testable and highly pluggable node.js applications, starting with a handful of common methods, like `set`, `get`, `del` and `use`.")
* [is-registered](https://www.npmjs.com/package/is-registered): Util for Base that optionally prevents a plugin from being registered more than once on… [more](https://github.com/jonschlinkert/is-registered) | [homepage](https://github.com/jonschlinkert/is-registered "Util for Base that optionally prevents a plugin from being registered more than once on an instance")
* [is-valid-instance](https://www.npmjs.com/package/is-valid-instance): Returns true if a value is a valid instance of Base. | [homepage](https://github.com/jonschlinkert/is-valid-instance "Returns true if a value is a valid instance of Base.")

### Contributing

Pull requests and stars are always welcome. For bugs and feature requests, [please create an issue](../../issues/new).

### Contributors

| **Commits** | **Contributor** | 
| --- | --- |
| 10 | [jonschlinkert](https://github.com/jonschlinkert) |
| 3 | [doowb](https://github.com/doowb) |

### Building docs

_(This project's readme.md is generated by [verb](https://github.com/verbose/verb-generate-readme), please don't edit the readme directly. Any changes to the readme must be made in the [.verb.md](.verb.md) readme template.)_

To generate the readme, run the following command:

```sh
$ npm install -g verbose/verb#dev verb-generate-readme && verb
```

### Running tests

Running and reviewing unit tests is a great way to get familiarized with a library and its API. You can install dependencies and run tests with the following command:

```sh
$ npm install && npm test
```

### Author

**Jon Schlinkert**

* [github/jonschlinkert](https://github.com/jonschlinkert)
* [twitter/jonschlinkert](https://twitter.com/jonschlinkert)

### License

Copyright © 2017, [Jon Schlinkert](https://github.com/jonschlinkert).
Released under the [MIT License](LICENSE).

***

_This file was generated by [verb-generate-readme](https://github.com/verbose/verb-generate-readme), v0.4.3, on March 24, 2017._